﻿Public Class frmLimiterConfiguration
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public FormLoading As Boolean = True
    Public MaxSensor As Integer = 65535
    Private Sub frmLimiterConfiguration_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        For Temp As Integer = 1 To 32
            DataTable.Rows.Add()
        Next Temp
        FillTableA()
        FormLoading = False

        Timer1.Interval = 3000
        Timer1.Start()

        If LimiterResolution.SelectedIndex = 0 Then MaxSensor = 255   '8-Bit
        If LimiterResolution.SelectedIndex = 1 Then MaxSensor = 1023  '10-Bit
        If LimiterResolution.SelectedIndex = 2 Then MaxSensor = 4095  '12-Bit
        If LimiterResolution.SelectedIndex = 3 Then MaxSensor = 16383 '14-Bit
        If LimiterResolution.SelectedIndex = 4 Then MaxSensor = 65535 '16-Bit

        SensorMaxLabel.Text = "Sensor Data (Maximum = " + MaxSensor.ToString + ")"
        RefreshLimits()

    End Sub

    Private Sub frmfrmLimiterConfiguration_Load(sender As Object, e As EventArgs) Handles MyBase.Closed

        Timer1.Stop()

    End Sub


    Public Sub FillTableA()

        Dim H(15) As Byte : H = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, StartAddress.Value, 16)
        Dim I(15) As Byte : I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, StartAddress.Value + 16, 16)

        If H IsNot Nothing And I IsNot Nothing Then

            'Display the First 16 Configuration Settings
            For Y As Integer = 0 To 15
                Dim Address As Double = StartAddress.Value + Y
                Dim Hex_Value As String
                Hex_Value = Hex(Address)
                CellData(0, Y, Address.ToString + "-" + Hex_Value)
                CellData(1, Y, Hex(H(Y)).ToString)
                CellData(2, Y, H(Y).ToString)
                CellData(3, Y, NCDLib.Enterprise.ProXR.Menu.GetDescription(Address))
            Next Y

            'Display the Limiter Configuration Settings
            For Y2 As Integer = 0 To 15
                Dim Address2 As Double = StartAddress.Value + Y2 + 16
                Dim Hex_Value As String
                Hex_Value = Hex(Address2)
                CellData(0, Y2 + 16, Address2.ToString + "-" + Hex_Value)
                CellData(1, Y2 + 16, Hex(I(Y2)).ToString)
                CellData(2, Y2 + 16, I(Y2).ToString)
                CellData(3, Y2 + 16, NCDLib.Enterprise.ProXR.Menu.GetDescription(Address2))
            Next Y2

            LimiterType.SelectedIndex = NCDLib.Safe.Limit_Value(I(4), 0, 4)
            LimiterResolution.SelectedIndex = NCDLib.Safe.Limit_Value(I(5), 0, 7)
            LowerLimit.Value = NCDLib.Safe.Limit_Value(((I(9) * 256) + I(10)), 0, MaxSensor)
            UpperLimit.Value = NCDLib.Safe.Limit_Value(((I(11) * 256) + I(12)), 0, MaxSensor)
            LowEvent.Value = NCDLib.Safe.Limit_Value(I(13), 0, 16)
            MidEvent.Value = NCDLib.Safe.Limit_Value(I(14), 0, 16)
            UpperEvent.Value = NCDLib.Safe.Limit_Value(I(15), 0, 16)

            UpperLimit.Maximum = MaxSensor
            LowerLimit.Maximum = MaxSensor

        End If



    End Sub
    Public Sub CellData(x As Integer, Y As Integer, Dat As String)
        'If FormLoading = False Then
        DataTable(x, Y).Value = Dat
        'End If
    End Sub
    Public Function GetCellData(x As Integer, Y As Integer) As String
        GetCellData = DataTable(x, Y).Value
    End Function
    Private Sub StartAddress_ValueChanged(sender As Object, e As EventArgs) Handles StartAddress.ValueChanged
        If FormLoading = False Then
            FillTableA()
        End If
    End Sub
    Private Sub SetLimiter_ValueChanged(sender As Object, e As EventArgs) Handles SetLimiter.ValueChanged
        StartAddress.Value = 5792 + ((SetLimiter.Value * 32) - 32)
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick

        Dim I(15) As Byte
        I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, StartAddress.Value + 16, 16)
        If I IsNot Nothing Then

            ActualLevel.Value = NCDLib.Safe.Limit_Value(((I(0) * 256) + I(1)), 0, MaxSensor)
            LastLevel.Value = NCDLib.Safe.Limit_Value(((I(2) * 256) + I(3)), 0, MaxSensor)

            Actual.Text = ActualLevel.Value.ToString
            Last.Text = LastLevel.Value.ToString

            ' For Y As Integer = 0 To 15
            '     Dim Address As Double = StartAddress.Value + Y
            '     Dim Hex_Value As String
            '     Hex_Value = Hex(Address)
            '     CellData(0, Y, Address.ToString + "-" + Hex_Value)
            '     CellData(1, Y, Hex(I(Y)).ToString)
            '     CellData(2, Y, I(Y).ToString)
            '     CellData(3, Y, NCDLib.Enterprise.ProXR.Menu.GetDescription(Address))
            ' Next Y
            '
            ' LimiterType.SelectedIndex = NCDLib.Safe.Limit_Value(I(4), 0, 7)
            ' LimiterResolution.SelectedIndex = NCDLib.Safe.Limit_Value(I(5), 0, 4)
            ' LowerLimit.Value = NCDLib.Safe.Limit_Value(((I(9) * 256) + I(10)), 0, 65535)
            ' UpperLimit.Value = NCDLib.Safe.Limit_Value(((I(11) * 256) + I(12)), 0, 65535)
            ' LowEvent.Value = NCDLib.Safe.Limit_Value(I(13), 0, 16)
            ' MidEvent.Value = NCDLib.Safe.Limit_Value(I(14), 0, 16)
            ' UpperEvent.Value = NCDLib.Safe.Limit_Value(I(15), 0, 16)

        End If

    End Sub

    Private Sub SaveLimiter_Click(sender As Object, e As EventArgs) Handles SaveLimiter.Click

        Dim I(15) As Byte
        For Temp As Integer = 0 To 15
            I(Temp) = GetCellData(2, Temp)
        Next Temp

        I(4) = LimiterType.SelectedIndex
        I(5) = LimiterResolution.SelectedIndex
        I(9) = NCDLib.Math.GetMSB(LowerLimit.Value)
        I(10) = NCDLib.Math.GetLSB(LowerLimit.Value)
        I(11) = NCDLib.Math.GetMSB(UpperLimit.Value)
        I(12) = NCDLib.Math.GetLSB(UpperLimit.Value)
        I(13) = LowEvent.Value
        I(14) = MidEvent.Value
        I(15) = UpperEvent.Value

        'Store Container Array at the Selected Start Address
        NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, StartAddress.Value, I)

        FillTableA()

    End Sub

    Private Sub UpperLimit_ValueChanged(sender As Object, e As EventArgs) Handles UpperLimit.ValueChanged

        If UpperLimit.Value <= LowerLimit.Value Then
            UpperLimit.Value = NCDLib.Safe.Limit_Value(UpperLimit.Value + 1, 0, MaxSensor)
        End If
    End Sub

    Private Sub LowerLimit_ValueChanged(sender As Object, e As EventArgs) Handles LowerLimit.ValueChanged

        If LimiterType.SelectedIndex = 2 Or LimiterType.SelectedIndex = 4 Then
            If LowerLimit.Value >= UpperLimit.Value Then
                ' LowerLimit.Value = UpperLimit.Value - 1

                UpperLimit.Value = NCDLib.Safe.Limit_Value(UpperLimit.Value - 1, 0, MaxSensor)

            End If
        End If

    End Sub

    Private Sub LimiterType_SelectedIndexChanged(sender As Object, e As EventArgs) Handles LimiterType.SelectedIndexChanged
        '0=None
        '1=Single Limit Real Time
        '2=Dual Limit Real Time
        '3=Single Limit Progressive
        '4=Dual Limit Progressive

        If LimiterType.SelectedIndex = 0 Then
            LimiterSettings.Visible = False
        Else
            LimiterSettings.Visible = True
        End If

        If LimiterType.SelectedIndex = 1 Or LimiterType.SelectedIndex = 3 Then
            UpperLimit.Visible = False
            UpperLimitLabel.Visible = False
            LowerLimitLabel.Text = "Limit"
            UpperEvent.Visible = False
            UpperEventLabel.Visible = False
            MidEventLabel.Text = "Upper Limit Macro Event"
        End If

        If LimiterType.SelectedIndex = 2 Or LimiterType.SelectedIndex = 4 Then
            UpperLimit.Visible = True
            UpperLimitLabel.Visible = True
            LowerLimitLabel.Text = "Lower Limit"
            UpperEvent.Visible = True
            UpperEventLabel.Visible = True
            MidEventLabel.Text = "Mid Limit Macro Event"
        End If

    End Sub

    Private Sub LimiterResolution_SelectedIndexChanged(sender As Object, e As EventArgs) Handles LimiterResolution.SelectedIndexChanged

        If FormLoading = True Then Exit Sub

        If LimiterResolution.SelectedIndex = 0 Then MaxSensor = 255   '8-Bit
        If LimiterResolution.SelectedIndex = 1 Then MaxSensor = 1023  '10-Bit
        If LimiterResolution.SelectedIndex = 2 Then MaxSensor = 4095  '12-Bit
        If LimiterResolution.SelectedIndex = 3 Then MaxSensor = 16383 '14-Bit
        If LimiterResolution.SelectedIndex = 4 Then MaxSensor = 65535 '16-Bit

        SensorMaxLabel.Text = "Sensor Data (Maximum = " + MaxSensor.ToString + ")"

        RefreshLimits()

    End Sub

    Public Sub RefreshLimits()

        Dim I(15) As Byte
        I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, StartAddress.Value, 16)
        If I IsNot Nothing Then
            ' For Y As Integer = 0 To 15
            '     Dim Address As Double = StartAddress.Value + Y
            '     Dim Hex_Value As String
            '     Hex_Value = Hex(Address)
            '     CellData(0, Y, Address.ToString + "-" + Hex_Value)
            '     CellData(1, Y, Hex(I(Y)).ToString)
            '     CellData(2, Y, I(Y).ToString)
            '     CellData(3, Y, NCDLib.Enterprise.ProXR.Menu.GetDescription(Address))
            ' Next Y

            'LimiterType.SelectedIndex = NCDLib.Safe.Limit_Value(I(4), 0, 4)
            'LimiterResolution.SelectedIndex = NCDLib.Safe.Limit_Value(I(5), 0, 7)

            LowerLimit.Maximum = MaxSensor
            UpperLimit.Maximum = MaxSensor

            ActualLevel.Maximum = 65535
            LastLevel.Maximum = 65535

            ActualLevel.Value = NCDLib.Safe.Limit_Value(((I(0) * 256) + I(1)), 0, MaxSensor)
            LastLevel.Value = NCDLib.Safe.Limit_Value(((I(2) * 256) + I(3)), 0, MaxSensor)

            ActualLevel.Maximum = MaxSensor
            LastLevel.Maximum = MaxSensor

            LowerLimit.Value = NCDLib.Safe.Limit_Value(((I(9) * 256) + I(10)), 0, MaxSensor)
            UpperLimit.Value = NCDLib.Safe.Limit_Value(((I(11) * 256) + I(12)), 0, MaxSensor)
            LowEvent.Value = NCDLib.Safe.Limit_Value(I(13), 0, 16)
            MidEvent.Value = NCDLib.Safe.Limit_Value(I(14), 0, 16)
            UpperEvent.Value = NCDLib.Safe.Limit_Value(I(15), 0, 16)

            SensorMaxLabel.Text = "Sensor Data (Maximum = " + MaxSensor.ToString + ")"
            'UpperLimit.Maximum = MaxSensor
            'LowerLimit.Maximum = MaxSensor
        End If

    End Sub

    Private Sub DetailView_CheckedChanged(sender As Object, e As EventArgs) Handles DetailView.CheckedChanged
        If DetailView.Checked = False Then
            Me.Width = 788
        Else
            Me.Width = 1069
        End If
    End Sub

    Private Sub EditMacros_Click(sender As Object, e As EventArgs) Handles EditMacros.Click
        Dim frm As frmMacros  ' define a form variable
        frm = New frmMacros      ' create the new form
        frm.NCDComponent1 = NCDComponent1   ' pass the NcdComponent object to ProXr form
        frm.ShowDialog()
    End Sub

    Private Sub FeedActual_Click(sender As Object, e As EventArgs) Handles FeedActual.Click

        If FormLoading = True Then Exit Sub

        ActualFeedTest()
        If DetailView.Checked = True Then
            FillTableOnly()
        End If
    End Sub

    Private Sub FeedLast_Click(sender As Object, e As EventArgs) Handles FeedLast.Click

        If FormLoading = True Then Exit Sub
        LastFeedTest()
        If DetailView.Checked = True Then
            FillTableOnly()
        End If
    End Sub

    Public Sub ActualFeedTest()
        Dim I(15) As Byte
        I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, StartAddress.Value, 16)
        If I IsNot Nothing Then

            I(0) = NCDLib.Math.GetMSB(TestFeedActual.Value)
            I(1) = NCDLib.Math.GetLSB(TestFeedActual.Value)


            'Store Container Array at the Selected Start Address
            NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, StartAddress.Value, I)

        End If
    End Sub

    Public Sub LastFeedTest()

        Dim I(15) As Byte
        I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, StartAddress.Value, 16)
        If I IsNot Nothing Then

            I(2) = NCDLib.Math.GetMSB(TestFeedLast.Value)
            I(3) = NCDLib.Math.GetLSB(TestFeedLast.Value)

            'Store Container Array at the Selected Start Address
            NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, StartAddress.Value, I)

        End If
    End Sub

    Private Sub TestFeedActual_ValueChanged(sender As Object, e As EventArgs) Handles TestFeedActual.ValueChanged

        If RTActualFeed.Checked = True Then
            ActualFeedTest()

            If DetailView.Checked = True Then
                FillTableOnly()
            End If
        End If

    End Sub

    Private Sub TestFeedLast_ValueChanged(sender As Object, e As EventArgs) Handles TestFeedLast.ValueChanged

        If RTLastFeed.Checked = True Then
            LastFeedTest()
            If DetailView.Checked = True Then
                FillTableOnly()
            End If
        End If

    End Sub

    Private Sub Refresh_Click(sender As Object, e As EventArgs) Handles Refresh.Click
        If FormLoading = False Then
            FillTableOnly
        End If

    End Sub
    Public Sub FillTableOnly()
        Dim I(15) As Byte
        I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, StartAddress.Value, 16)
        If I IsNot Nothing Then
            For Y As Integer = 0 To 15
                Dim Address As Double = StartAddress.Value + Y
                Dim Hex_Value As String
                Hex_Value = Hex(Address)
                CellData(0, Y, Address.ToString + "-" + Hex_Value)
                CellData(1, Y, Hex(I(Y)).ToString)
                CellData(2, Y, I(Y).ToString)
                CellData(3, Y, NCDLib.Enterprise.ProXR.Menu.GetDescription(Address))
            Next Y
        End If

    End Sub
    Private Sub SourceA_CheckedChanged(sender As Object, e As EventArgs) Handles SourceA.CheckedChanged
        I2CSources.Visible = True
        WirelessSources.Visible = False
        AnalogSources.Visible = False
    End Sub
    Private Sub SourceB_CheckedChanged(sender As Object, e As EventArgs) Handles SourceB.CheckedChanged
        I2CSources.Visible = False
        WirelessSources.Visible = True
        AnalogSources.Visible = False
    End Sub
    Private Sub SourceC_CheckedChanged(sender As Object, e As EventArgs) Handles SourceC.CheckedChanged
        I2CSources.Visible = False
        WirelessSources.Visible = False
        AnalogSources.Visible = True
    End Sub
End Class