﻿Imports ConfigurationUtility
Public Class frmProXRIndividualRelays
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public UsingAPI As Boolean = frmMain.UsingAPI ' flag for if using API mode

    Private Sub frmProXRIndividualRelays_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        If UsingAPI = True Then
            Me.Text = Me.Text + " (API Mode)"
        End If

        Dim I As Integer
        I = (GetAttachedBanks() * 8) - 1 'Ask Controller How Many Banks are Available & Calculate the Maximum Slider Value
        If I > 0 Then
            TurnOnSelected.Maximum = I
            TurnOffSelected.Maximum = I
            SBBM.Maximum = I
            ReadSelected.Maximum = I
        Else
            Exit Sub
        End If
    End Sub
    Public Function GetAttachedBanks()
        Dim I As Integer
        I = GetEE(10)   'New Memory Location for Reading Attached Banks        ''This was the OLD ProXR Command that was Removed
        If I > 0 Then                                                          'NCDComponent1.Purge()
            GetAttachedBanks = I                                               'NCDComponent1.WriteByte(254)
        Else                                                                   'NCDComponent1.WriteByte(50)
            MsgBox("Unable to Communicate with Controller.")                   'NCDComponent1.WriteByte(140)
            GetAttachedBanks = 0
        End If
    End Function
    Public Function GetEE(Addr As Integer)
        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 53, Addr)
        'NCDComponent1.Purge()
        'NCDComponent1.WriteByte(254)
        'NCDComponent1.WriteByte(53)
        'NCDComponent1.WriteByte(Addr)
        GetEE = Confirm()
        If GetEE = -1 Then
            GetEE = 0
        End If
    End Function
    Public Function Confirm()
        Confirm = NCDLib.ReadByteAPI(NCDComponent1, UsingAPI)
        'Confirm = NCDComponent1.ReadByte
        ' If Confirm <> 85 Then
        'MsgBox("Communications Error.  Device did not respond as expected.")
        ' End If
        'Application.DoEvents()
    End Function
    Private Sub TurnOnSelected_Scroll(sender As System.Object, e As System.Windows.Forms.ScrollEventArgs) Handles TurnOnSelected.Scroll
        TextBox1.Text = TurnOnSelected.Value
        TextBox1.Refresh()
    End Sub
    Private Sub TurnOnSelected_ValueChanged(sender As Object, e As System.EventArgs) Handles TurnOnSelected.ValueChanged
        TextBox1.Text = TurnOnSelected.Value
        Dim I As Integer
        Dim LSB As Integer
        Dim MSB As Integer
        LSB = ((TurnOnSelected.Value) And 255)
        MSB = (((TurnOnSelected.Value) And 65280) / 255)
        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 48, LSB, MSB)
        I = NCDLib.ReadByteAPI(NCDComponent1, UsingAPI)
        CMD_Data("Turn On Selected Relay:", "", False)
    End Sub
    Private Sub TurnOffSelected_Scroll(sender As System.Object, e As System.Windows.Forms.ScrollEventArgs) Handles TurnOffSelected.Scroll
        TextBox2.Text = TurnOffSelected.Value
        TextBox2.Refresh()
    End Sub
    Private Sub TurnOffSelected_ValueChanged(sender As Object, e As System.EventArgs) Handles TurnOffSelected.ValueChanged
        TextBox2.Text = TurnOffSelected.Value
        Dim I As Integer
        Dim LSB As Integer
        Dim MSB As Integer
        LSB = ((TurnOffSelected.Value) And 255)
        MSB = (((TurnOffSelected.Value) And 65280) / 255)
        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 47, LSB, MSB)
        I = NCDLib.ReadByteAPI(NCDComponent1, UsingAPI)
        CMD_Data("Turn Off Selected Relay:", "", False)
    End Sub
    Private Sub SBBM_Scroll(sender As System.Object, e As System.Windows.Forms.ScrollEventArgs) Handles SBBM.Scroll
        TextBox3.Text = SBBM.Value
        TextBox3.Refresh()
    End Sub
    Private Sub SBBM_ValueChanged(sender As Object, e As System.EventArgs) Handles SBBM.ValueChanged
        TextBox3.Text = SBBM.Value
        Dim I As Integer
        Dim LSB As Integer
        Dim MSB As Integer
        LSB = ((SBBM.Value) And 255)
        MSB = (((SBBM.Value) And 65280) / 255)
        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 46, LSB, MSB)
        I = NCDLib.ReadByteAPI(NCDComponent1, UsingAPI)
        CMD_Data("Turn Off All Relays, Turn On Selected Relay (Safe Break Before Make):", "", False)
    End Sub
    Private Sub ReadSelected_Scroll(sender As System.Object, e As System.Windows.Forms.ScrollEventArgs) Handles ReadSelected.Scroll
        TextBox4.Text = ReadSelected.Value
        TextBox4.Refresh()
        TextBox5.Refresh()
    End Sub
    Private Sub ReadSelected_ValueChanged(sender As Object, e As System.EventArgs) Handles ReadSelected.ValueChanged
        TextBox4.Text = ReadSelected.Value
        Dim I As Integer
        Dim LSB As Integer
        Dim MSB As Integer
        LSB = ((ReadSelected.Value) And 255)
        MSB = (((ReadSelected.Value) And 65280) / 255)
        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 44, LSB, MSB)
        I = NCDLib.ReadByteAPI(NCDComponent1, UsingAPI)
        If I = 0 Then
            TextBox5.Text = "OFF"
        Else
            TextBox5.Text = "ON"
        End If
        TextBox5.Refresh()
        CMD_Data("Read On/Off Status of Selected Relay:", "", False)
    End Sub

    Public Sub CMD_Data(Description As String, Component As String, OneWay As Boolean)
        CMD_Description.Text = Description
        If OneWay = False Then
            If UsingAPI = True Then
                CMD_Transmit.Text = NCDLib.GetLastTransmitString() & "        NOTE: API Mode is ON, Communication Data are Shown in API Format"
            Else
                CMD_Transmit.Text = NCDLib.GetLastTransmitString()
            End If
        Else
            CMD_Transmit.Text = "No Bytes Received from This Command"
        End If
            CMD_Receive.Text = NCDLib.GetLastReceivingString()
            CMD_Method.Text = Component '"NCDComponent1.ProXR.RelayBanks.TurnOnRelay(1)"
    End Sub
    Public Sub LinkTo(ByVal Address As String)
        Try
            System.Diagnostics.Process.Start(Address) ' start browser for that link
        Catch ex As Exception
        End Try
    End Sub
    Private Sub LinkLabel1_LinkClicked_1(sender As System.Object, e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles LinkLabel1.LinkClicked
        LinkTo("https://ncd.io/proxr-quick-start-guide/")
    End Sub


    Private Sub MORE_Click(sender As System.Object, e As System.EventArgs) Handles MORE.Click
        If MORE.Text = "MORE" Then
            MORE.Text = "LESS"
            Me.Height = 426 'TALL
            Me.Height = GroupBox23.Top + GroupBox23.Height + frmMain.OSOffset + 20
        Else
            MORE.Text = "MORE"
            Me.Height = 291 'SHORT
            Me.Height = GroupBox4.Top + GroupBox4.Height + frmMain.OSOffset
        End If
    End Sub
End Class